// CPPConst.cpp: constants used by CPPParser and auxilliary classes

#include "CPPConst.h"

const CPPConst::TypeSpecifier CPPConst::tsNONE(0x0L);
const CPPConst::TypeSpecifier CPPConst::tsVOID(0x1L);
const CPPConst::TypeSpecifier CPPConst::tsCHAR(0x2L);
const CPPConst::TypeSpecifier CPPConst::tsSHORT(0x4L);
const CPPConst::TypeSpecifier CPPConst::tsINT(0x8L);
const CPPConst::TypeSpecifier CPPConst::tsLONG(0x10L);
const CPPConst::TypeSpecifier CPPConst::tsFLOAT(0x20L);
const CPPConst::TypeSpecifier CPPConst::tsDOUBLE(0x40L);
const CPPConst::TypeSpecifier CPPConst::tsSIGNED(0x80L);
const CPPConst::TypeSpecifier CPPConst::tsUNSIGNED(0x100L);
const CPPConst::TypeSpecifier CPPConst::tsTYPEID(0x200L);
const CPPConst::TypeSpecifier CPPConst::tsSTRUCT(0x400L);
const CPPConst::TypeSpecifier CPPConst::tsENUM(0x800L);
const CPPConst::TypeSpecifier CPPConst::tsUNION(0x1000L);
const CPPConst::TypeSpecifier CPPConst::tsCLASS(0x2000L);
const CPPConst::TypeSpecifier CPPConst::tsWCHAR_T(0x4000L);
const CPPConst::TypeSpecifier CPPConst::tsBOOL(0x8000L);
const CPPConst::TypeSpecifier CPPConst::tsINT64(0x10000L);

const CPPConst::CVQualifier CPPConst::cvNONE(0x0);
const CPPConst::CVQualifier CPPConst::cvCONST(0x1);
const CPPConst::CVQualifier CPPConst::cvVOLATILE(0x2);

const CPPConst::StorageClass CPPConst::scNONE(0x0);
const CPPConst::StorageClass CPPConst::scAUTO(0x1);
const CPPConst::StorageClass CPPConst::scREGISTER(0x2);
const CPPConst::StorageClass CPPConst::scSTATIC(0x4);
const CPPConst::StorageClass CPPConst::scEXTERN(0x8);
const CPPConst::StorageClass CPPConst::scTYPEDEF(0x10);
const CPPConst::StorageClass CPPConst::scMSDLLImport(0x20);
const CPPConst::StorageClass CPPConst::scMSDLLExport(0x40);
const CPPConst::StorageClass CPPConst::scMSBased(0x80);

const CPPConst::DeclModifier CPPConst::dmNONE(0x0);
const CPPConst::DeclModifier CPPConst::dmVIRTUAL(0x1);
const CPPConst::DeclModifier CPPConst::dmINLINE(0x2);
const CPPConst::DeclModifier CPPConst::dmFRIEND(0x4);
const CPPConst::DeclModifier CPPConst::dmEXPLICIT(0x8);

const CPPConst::CallingConvention CPPConst::ccCDECL(0x0);
const CPPConst::CallingConvention CPPConst::ccMS_FASTCALL(0x1);
const CPPConst::CallingConvention CPPConst::ccMS_STDCALL(0x2);

const CPPConst::AccessSpecifier CPPConst::asNONE(0x0);
const CPPConst::AccessSpecifier CPPConst::asPUBLIC(0x1);
const CPPConst::AccessSpecifier CPPConst::asPROTECTED(0x2);
const CPPConst::AccessSpecifier CPPConst::asPRIVATE(0x4);

const CPPConst::BaseSpecifier CPPConst::bsNONE(0x0);
const CPPConst::BaseSpecifier CPPConst::bsPUBLIC(0x1);
const CPPConst::BaseSpecifier CPPConst::bsPROTECTED(0x2);
const CPPConst::BaseSpecifier CPPConst::bsPRIVATE(0x4);
const CPPConst::BaseSpecifier CPPConst::bsVIRTUAL(0x8);

