#
# unmod_hdr.sh: Check the file CPPParser.h again a reference created
# earlier, and if there is no change, set the date back "a ways".
#

if [ -f Debug/CPPParser.h.ref ]
then
	cmp CPPParser.h Debug/CPPParser.h.ref
	if [ $? = 0 ]
	then
		# same -- set time back to that of reference file
		echo "same -- resetting file times"
		touch -c -r Debug/CPPParser.h.ref CPPParser.h
	else
		# different -- update reference to match actual file
		echo "different -- updating reference"
		cp CPPParser.h Debug/CPPParser.h.ref
	fi
else
	# missing reference -- create it
	cp CPPParser.h Debug/CPPParser.h.ref
fi
