#ifndef DLGLexer_h
#define DLGLexer_h
/*
 * D L G L e x e r  C l a s s  D e f i n i t i o n
 *
 * Generated from: parser.dlg
 *
 * 1989-1994 by  Will Cohen, Terence Parr, and Hank Dietz
 * Purdue University Electrical Engineering
 * DLG Version 1.33
 */


#include "DLexerBase.h"

class DLGLexer : public DLGLexerBase {
public:
	static const int MAX_MODE;
	static const int DfaStates;
	static const int START;
	static const int DIRECTIVE_MODE;
	static const int DEFINING;
	static const int MLCOMMENT;
	static const int STRINGS;
	static const int CHARACTERS;
	typedef unsigned short DfaState;

	DLGLexer(DLGInputStream *in)
		: DLGLexerBase(in)
		  , firstLineToken(1)
	{
	;
	}
	void	mode(int);
	ANTLRTokenType nextTokenType(void);
	void	advance(void);
	int firstLineToken;
protected:
	ANTLRTokenType act1();
	ANTLRTokenType act2();
	ANTLRTokenType act3();
	ANTLRTokenType act4();
	ANTLRTokenType act5();
	ANTLRTokenType act6();
	ANTLRTokenType act7();
	ANTLRTokenType act8();
	ANTLRTokenType act9();
	ANTLRTokenType act10();
	ANTLRTokenType act11();
	ANTLRTokenType act12();
	ANTLRTokenType act13();
	ANTLRTokenType act14();
	ANTLRTokenType act15();
	ANTLRTokenType act16();
	ANTLRTokenType act17();
	ANTLRTokenType act18();
	ANTLRTokenType act19();
	ANTLRTokenType act20();
	ANTLRTokenType act21();
	ANTLRTokenType act22();
	ANTLRTokenType act23();
	ANTLRTokenType act24();
	ANTLRTokenType act25();
	ANTLRTokenType act26();
	ANTLRTokenType act27();
	ANTLRTokenType act28();
	ANTLRTokenType act29();
	ANTLRTokenType act30();
	ANTLRTokenType act31();
	ANTLRTokenType act32();
	ANTLRTokenType act33();
	ANTLRTokenType act34();
	ANTLRTokenType act35();
	ANTLRTokenType act36();
	ANTLRTokenType act37();
	ANTLRTokenType act38();
	ANTLRTokenType act39();
	ANTLRTokenType act40();
	ANTLRTokenType act41();
	ANTLRTokenType act42();
	ANTLRTokenType act43();
	ANTLRTokenType act44();
	ANTLRTokenType act45();
	ANTLRTokenType act46();
	ANTLRTokenType act47();
	ANTLRTokenType act48();
	ANTLRTokenType act49();
	ANTLRTokenType act50();
	ANTLRTokenType act51();
	ANTLRTokenType act52();
	ANTLRTokenType act53();
	ANTLRTokenType act54();
	ANTLRTokenType act55();
	ANTLRTokenType act56();
	ANTLRTokenType act57();
	ANTLRTokenType act58();
	ANTLRTokenType act59();
	ANTLRTokenType act60();
	ANTLRTokenType act61();
	ANTLRTokenType act62();
	ANTLRTokenType act63();
	ANTLRTokenType act64();
	ANTLRTokenType act65();
	ANTLRTokenType act66();
	ANTLRTokenType act67();
	ANTLRTokenType act68();
	ANTLRTokenType act69();
	ANTLRTokenType act70();
	ANTLRTokenType act71();
	ANTLRTokenType act72();
	ANTLRTokenType act73();
	ANTLRTokenType act74();
	ANTLRTokenType act75();
	ANTLRTokenType act76();
	ANTLRTokenType act77();
	ANTLRTokenType act78();
	ANTLRTokenType act79();
	ANTLRTokenType act80();
	ANTLRTokenType act81();
	ANTLRTokenType act82();
	ANTLRTokenType act83();
	ANTLRTokenType act84();
	ANTLRTokenType act85();
	ANTLRTokenType act86();
	ANTLRTokenType act87();
	ANTLRTokenType act88();
	ANTLRTokenType act89();
	ANTLRTokenType act90();
	ANTLRTokenType act91();
	ANTLRTokenType act92();
	ANTLRTokenType act93();
	ANTLRTokenType act94();
	ANTLRTokenType act95();
	ANTLRTokenType act96();
	ANTLRTokenType act97();
	ANTLRTokenType act98();
	ANTLRTokenType act99();
	ANTLRTokenType act100();
	ANTLRTokenType act101();
	ANTLRTokenType act102();
	ANTLRTokenType act103();
	ANTLRTokenType act104();
	ANTLRTokenType act105();
	ANTLRTokenType act106();
	ANTLRTokenType act107();
	ANTLRTokenType act108();
	ANTLRTokenType act109();
	ANTLRTokenType act110();
	ANTLRTokenType act111();
	ANTLRTokenType act112();
	ANTLRTokenType act113();
	ANTLRTokenType act114();
	ANTLRTokenType act115();
	ANTLRTokenType act116();
	ANTLRTokenType act117();
	ANTLRTokenType act118();
	ANTLRTokenType act119();
	ANTLRTokenType act120();
	ANTLRTokenType act121();
	ANTLRTokenType act122();
	ANTLRTokenType act123();
	ANTLRTokenType act124();
	ANTLRTokenType act125();
	ANTLRTokenType act126();
	ANTLRTokenType act127();
	ANTLRTokenType act128();
	ANTLRTokenType act129();
	ANTLRTokenType act130();
	ANTLRTokenType act131();
	ANTLRTokenType act132();
	ANTLRTokenType act133();
	ANTLRTokenType act134();
	ANTLRTokenType act135();
	ANTLRTokenType act136();
	ANTLRTokenType act137();
	ANTLRTokenType act138();
	ANTLRTokenType act139();
	ANTLRTokenType act140();
	ANTLRTokenType act141();
	ANTLRTokenType act142();
	ANTLRTokenType act143();
	ANTLRTokenType act144();
	ANTLRTokenType act145();
	ANTLRTokenType act146();
	ANTLRTokenType act147();
	ANTLRTokenType act148();
	ANTLRTokenType act149();
	ANTLRTokenType act150();
	ANTLRTokenType act151();
	ANTLRTokenType act152();
	ANTLRTokenType act153();
	ANTLRTokenType act154();
	ANTLRTokenType act155();
	ANTLRTokenType act156();
	ANTLRTokenType act157();
	ANTLRTokenType act158();
	ANTLRTokenType act159();
	ANTLRTokenType act160();
	ANTLRTokenType act161();
	ANTLRTokenType act162();
	ANTLRTokenType act163();
	ANTLRTokenType act164();
	ANTLRTokenType act165();
	ANTLRTokenType act166();
	ANTLRTokenType act167();
	ANTLRTokenType act168();
	ANTLRTokenType act169();
	ANTLRTokenType act170();
	ANTLRTokenType act171();
	ANTLRTokenType act172();
	ANTLRTokenType act173();
	ANTLRTokenType act174();
	ANTLRTokenType act175();
	ANTLRTokenType act176();
	ANTLRTokenType act177();
	static DfaState st0[75];
	static DfaState st1[75];
	static DfaState st2[75];
	static DfaState st3[75];
	static DfaState st4[75];
	static DfaState st5[75];
	static DfaState st6[75];
	static DfaState st7[75];
	static DfaState st8[75];
	static DfaState st9[75];
	static DfaState st10[75];
	static DfaState st11[75];
	static DfaState st12[75];
	static DfaState st13[75];
	static DfaState st14[75];
	static DfaState st15[75];
	static DfaState st16[75];
	static DfaState st17[75];
	static DfaState st18[75];
	static DfaState st19[75];
	static DfaState st20[75];
	static DfaState st21[75];
	static DfaState st22[75];
	static DfaState st23[75];
	static DfaState st24[75];
	static DfaState st25[75];
	static DfaState st26[75];
	static DfaState st27[75];
	static DfaState st28[75];
	static DfaState st29[75];
	static DfaState st30[75];
	static DfaState st31[75];
	static DfaState st32[75];
	static DfaState st33[75];
	static DfaState st34[75];
	static DfaState st35[75];
	static DfaState st36[75];
	static DfaState st37[75];
	static DfaState st38[75];
	static DfaState st39[75];
	static DfaState st40[75];
	static DfaState st41[75];
	static DfaState st42[75];
	static DfaState st43[75];
	static DfaState st44[75];
	static DfaState st45[75];
	static DfaState st46[75];
	static DfaState st47[75];
	static DfaState st48[75];
	static DfaState st49[75];
	static DfaState st50[75];
	static DfaState st51[75];
	static DfaState st52[75];
	static DfaState st53[75];
	static DfaState st54[75];
	static DfaState st55[75];
	static DfaState st56[75];
	static DfaState st57[75];
	static DfaState st58[75];
	static DfaState st59[75];
	static DfaState st60[75];
	static DfaState st61[75];
	static DfaState st62[75];
	static DfaState st63[75];
	static DfaState st64[75];
	static DfaState st65[75];
	static DfaState st66[75];
	static DfaState st67[75];
	static DfaState st68[75];
	static DfaState st69[75];
	static DfaState st70[75];
	static DfaState st71[75];
	static DfaState st72[75];
	static DfaState st73[75];
	static DfaState st74[75];
	static DfaState st75[75];
	static DfaState st76[75];
	static DfaState st77[75];
	static DfaState st78[75];
	static DfaState st79[75];
	static DfaState st80[75];
	static DfaState st81[75];
	static DfaState st82[75];
	static DfaState st83[75];
	static DfaState st84[75];
	static DfaState st85[75];
	static DfaState st86[75];
	static DfaState st87[75];
	static DfaState st88[75];
	static DfaState st89[75];
	static DfaState st90[75];
	static DfaState st91[75];
	static DfaState st92[75];
	static DfaState st93[75];
	static DfaState st94[75];
	static DfaState st95[75];
	static DfaState st96[75];
	static DfaState st97[75];
	static DfaState st98[75];
	static DfaState st99[75];
	static DfaState st100[75];
	static DfaState st101[75];
	static DfaState st102[75];
	static DfaState st103[75];
	static DfaState st104[75];
	static DfaState st105[75];
	static DfaState st106[75];
	static DfaState st107[75];
	static DfaState st108[75];
	static DfaState st109[75];
	static DfaState st110[75];
	static DfaState st111[75];
	static DfaState st112[75];
	static DfaState st113[75];
	static DfaState st114[75];
	static DfaState st115[75];
	static DfaState st116[75];
	static DfaState st117[75];
	static DfaState st118[75];
	static DfaState st119[75];
	static DfaState st120[75];
	static DfaState st121[75];
	static DfaState st122[75];
	static DfaState st123[75];
	static DfaState st124[75];
	static DfaState st125[75];
	static DfaState st126[75];
	static DfaState st127[75];
	static DfaState st128[75];
	static DfaState st129[75];
	static DfaState st130[75];
	static DfaState st131[75];
	static DfaState st132[75];
	static DfaState st133[75];
	static DfaState st134[75];
	static DfaState st135[75];
	static DfaState st136[75];
	static DfaState st137[75];
	static DfaState st138[75];
	static DfaState st139[75];
	static DfaState st140[75];
	static DfaState st141[75];
	static DfaState st142[75];
	static DfaState st143[75];
	static DfaState st144[75];
	static DfaState st145[75];
	static DfaState st146[75];
	static DfaState st147[75];
	static DfaState st148[75];
	static DfaState st149[75];
	static DfaState st150[75];
	static DfaState st151[75];
	static DfaState st152[75];
	static DfaState st153[75];
	static DfaState st154[75];
	static DfaState st155[75];
	static DfaState st156[75];
	static DfaState st157[75];
	static DfaState st158[75];
	static DfaState st159[75];
	static DfaState st160[75];
	static DfaState st161[75];
	static DfaState st162[75];
	static DfaState st163[75];
	static DfaState st164[75];
	static DfaState st165[75];
	static DfaState st166[75];
	static DfaState st167[75];
	static DfaState st168[75];
	static DfaState st169[75];
	static DfaState st170[75];
	static DfaState st171[75];
	static DfaState st172[75];
	static DfaState st173[75];
	static DfaState st174[75];
	static DfaState st175[75];
	static DfaState st176[75];
	static DfaState st177[75];
	static DfaState st178[75];
	static DfaState st179[75];
	static DfaState st180[75];
	static DfaState st181[75];
	static DfaState st182[75];
	static DfaState st183[75];
	static DfaState st184[75];
	static DfaState st185[75];
	static DfaState st186[75];
	static DfaState st187[75];
	static DfaState st188[75];
	static DfaState st189[75];
	static DfaState st190[75];
	static DfaState st191[75];
	static DfaState st192[75];
	static DfaState st193[75];
	static DfaState st194[75];
	static DfaState st195[75];
	static DfaState st196[75];
	static DfaState st197[75];
	static DfaState st198[75];
	static DfaState st199[75];
	static DfaState st200[75];
	static DfaState st201[75];
	static DfaState st202[75];
	static DfaState st203[75];
	static DfaState st204[75];
	static DfaState st205[75];
	static DfaState st206[75];
	static DfaState st207[75];
	static DfaState st208[75];
	static DfaState st209[75];
	static DfaState st210[75];
	static DfaState st211[75];
	static DfaState st212[75];
	static DfaState st213[75];
	static DfaState st214[75];
	static DfaState st215[75];
	static DfaState st216[75];
	static DfaState st217[75];
	static DfaState st218[75];
	static DfaState st219[75];
	static DfaState st220[75];
	static DfaState st221[75];
	static DfaState st222[75];
	static DfaState st223[75];
	static DfaState st224[75];
	static DfaState st225[75];
	static DfaState st226[75];
	static DfaState st227[75];
	static DfaState st228[75];
	static DfaState st229[75];
	static DfaState st230[75];
	static DfaState st231[75];
	static DfaState st232[75];
	static DfaState st233[75];
	static DfaState st234[75];
	static DfaState st235[75];
	static DfaState st236[75];
	static DfaState st237[75];
	static DfaState st238[75];
	static DfaState st239[75];
	static DfaState st240[75];
	static DfaState st241[75];
	static DfaState st242[75];
	static DfaState st243[75];
	static DfaState st244[75];
	static DfaState st245[75];
	static DfaState st246[75];
	static DfaState st247[75];
	static DfaState st248[75];
	static DfaState st249[75];
	static DfaState st250[75];
	static DfaState st251[75];
	static DfaState st252[75];
	static DfaState st253[75];
	static DfaState st254[75];
	static DfaState st255[75];
	static DfaState st256[75];
	static DfaState st257[75];
	static DfaState st258[75];
	static DfaState st259[75];
	static DfaState st260[75];
	static DfaState st261[75];
	static DfaState st262[75];
	static DfaState st263[75];
	static DfaState st264[75];
	static DfaState st265[75];
	static DfaState st266[75];
	static DfaState st267[75];
	static DfaState st268[75];
	static DfaState st269[75];
	static DfaState st270[75];
	static DfaState st271[75];
	static DfaState st272[75];
	static DfaState st273[75];
	static DfaState st274[75];
	static DfaState st275[75];
	static DfaState st276[75];
	static DfaState st277[75];
	static DfaState st278[75];
	static DfaState st279[75];
	static DfaState st280[75];
	static DfaState st281[75];
	static DfaState st282[75];
	static DfaState st283[75];
	static DfaState st284[75];
	static DfaState st285[75];
	static DfaState st286[75];
	static DfaState st287[75];
	static DfaState st288[75];
	static DfaState st289[75];
	static DfaState st290[75];
	static DfaState st291[75];
	static DfaState st292[75];
	static DfaState st293[75];
	static DfaState st294[75];
	static DfaState st295[75];
	static DfaState st296[75];
	static DfaState st297[75];
	static DfaState st298[75];
	static DfaState st299[75];
	static DfaState st300[75];
	static DfaState st301[75];
	static DfaState st302[75];
	static DfaState st303[75];
	static DfaState st304[75];
	static DfaState st305[75];
	static DfaState st306[75];
	static DfaState st307[75];
	static DfaState st308[75];
	static DfaState st309[75];
	static DfaState st310[75];
	static DfaState st311[75];
	static DfaState st312[75];
	static DfaState st313[75];
	static DfaState st314[75];
	static DfaState st315[75];
	static DfaState st316[75];
	static DfaState st317[75];
	static DfaState st318[75];
	static DfaState st319[75];
	static DfaState st320[75];
	static DfaState st321[75];
	static DfaState st322[75];
	static DfaState st323[75];
	static DfaState st324[75];
	static DfaState st325[75];
	static DfaState st326[75];
	static DfaState st327[75];
	static DfaState st328[75];
	static DfaState st329[75];
	static DfaState st330[75];
	static DfaState st331[75];
	static DfaState st332[75];
	static DfaState st333[75];
	static DfaState st334[75];
	static DfaState st335[75];
	static DfaState st336[75];
	static DfaState st337[75];
	static DfaState st338[75];
	static DfaState st339[75];
	static DfaState st340[75];
	static DfaState st341[75];
	static DfaState st342[75];
	static DfaState st343[75];
	static DfaState st344[75];
	static DfaState st345[75];
	static DfaState st346[75];
	static DfaState st347[75];
	static DfaState st348[75];
	static DfaState st349[75];
	static DfaState st350[75];
	static DfaState st351[75];
	static DfaState st352[75];
	static DfaState st353[75];
	static DfaState st354[75];
	static DfaState st355[75];
	static DfaState st356[75];
	static DfaState st357[75];
	static DfaState st358[75];
	static DfaState st359[75];
	static DfaState st360[75];
	static DfaState st361[75];
	static DfaState st362[75];
	static DfaState st363[75];
	static DfaState st364[75];
	static DfaState st365[75];
	static DfaState st366[75];
	static DfaState st367[75];
	static DfaState st368[75];
	static DfaState st369[75];
	static DfaState st370[75];
	static DfaState st371[75];
	static DfaState st372[75];
	static DfaState st373[75];
	static DfaState st374[75];
	static DfaState st375[75];
	static DfaState st376[75];
	static DfaState st377[75];
	static DfaState st378[75];
	static DfaState st379[75];
	static DfaState st380[75];
	static DfaState st381[75];
	static DfaState st382[75];
	static DfaState st383[75];
	static DfaState st384[75];
	static DfaState st385[75];
	static DfaState st386[75];
	static DfaState st387[75];
	static DfaState st388[75];
	static DfaState st389[75];
	static DfaState st390[75];
	static DfaState st391[75];
	static DfaState st392[75];
	static DfaState st393[75];
	static DfaState st394[75];
	static DfaState st395[75];
	static DfaState st396[75];
	static DfaState st397[75];
	static DfaState st398[75];
	static DfaState st399[75];
	static DfaState st400[75];
	static DfaState st401[75];
	static DfaState st402[75];
	static DfaState st403[75];
	static DfaState st404[75];
	static DfaState st405[75];
	static DfaState st406[75];
	static DfaState st407[75];
	static DfaState st408[75];
	static DfaState st409[75];
	static DfaState st410[75];
	static DfaState st411[75];
	static DfaState st412[75];
	static DfaState st413[75];
	static DfaState st414[75];
	static DfaState st415[75];
	static DfaState st416[75];
	static DfaState st417[75];
	static DfaState st418[75];
	static DfaState st419[75];
	static DfaState st420[75];
	static DfaState st421[75];
	static DfaState st422[75];
	static DfaState st423[75];
	static DfaState st424[75];
	static DfaState st425[75];
	static DfaState st426[75];
	static DfaState st427[75];
	static DfaState st428[75];
	static DfaState st429[75];
	static DfaState st430[75];
	static DfaState st431[75];
	static DfaState st432[75];
	static DfaState st433[75];
	static DfaState st434[75];
	static DfaState st435[75];
	static DfaState st436[75];
	static DfaState st437[75];
	static DfaState st438[75];
	static DfaState st439[75];
	static DfaState st440[75];
	static DfaState st441[75];
	static DfaState st442[75];
	static DfaState st443[75];
	static DfaState st444[75];
	static DfaState st445[75];
	static DfaState st446[75];
	static DfaState st447[75];
	static DfaState st448[75];
	static DfaState st449[75];
	static DfaState st450[75];
	static DfaState st451[75];
	static DfaState st452[75];
	static DfaState st453[75];
	static DfaState st454[75];
	static DfaState st455[75];
	static DfaState st456[75];
	static DfaState st457[75];
	static DfaState st458[75];
	static DfaState st459[75];
	static DfaState st460[75];
	static DfaState st461[75];
	static DfaState st462[75];
	static DfaState st463[75];
	static DfaState st464[75];
	static DfaState st465[18];
	static DfaState st466[18];
	static DfaState st467[18];
	static DfaState st468[18];
	static DfaState st469[18];
	static DfaState st470[18];
	static DfaState st471[18];
	static DfaState st472[18];
	static DfaState st473[18];
	static DfaState st474[18];
	static DfaState st475[18];
	static DfaState st476[18];
	static DfaState st477[18];
	static DfaState st478[18];
	static DfaState st479[18];
	static DfaState st480[18];
	static DfaState st481[18];
	static DfaState st482[18];
	static DfaState st483[18];
	static DfaState st484[18];
	static DfaState st485[18];
	static DfaState st486[18];
	static DfaState st487[18];
	static DfaState st488[18];
	static DfaState st489[18];
	static DfaState st490[18];
	static DfaState st491[18];
	static DfaState st492[18];
	static DfaState st493[18];
	static DfaState st494[18];
	static DfaState st495[18];
	static DfaState st496[18];
	static DfaState st497[18];
	static DfaState st498[18];
	static DfaState st499[18];
	static DfaState st500[18];
	static DfaState st501[18];
	static DfaState st502[18];
	static DfaState st503[18];
	static DfaState st504[18];
	static DfaState st505[18];
	static DfaState st506[18];
	static DfaState st507[18];
	static DfaState st508[18];
	static DfaState st509[18];
	static DfaState st510[18];
	static DfaState st511[18];
	static DfaState st512[18];
	static DfaState st513[18];
	static DfaState st514[18];
	static DfaState st515[18];
	static DfaState st516[18];
	static DfaState st517[18];
	static DfaState st518[6];
	static DfaState st519[6];
	static DfaState st520[6];
	static DfaState st521[6];
	static DfaState st522[6];
	static DfaState st523[6];
	static DfaState st524[6];
	static DfaState st525[6];
	static DfaState st526[6];
	static DfaState st527[6];
	static DfaState st528[6];
	static DfaState st529[6];
	static DfaState st530[12];
	static DfaState st531[12];
	static DfaState st532[12];
	static DfaState st533[12];
	static DfaState st534[12];
	static DfaState st535[12];
	static DfaState st536[12];
	static DfaState st537[12];
	static DfaState st538[12];
	static DfaState st539[12];
	static DfaState st540[12];
	static DfaState st541[11];
	static DfaState st542[11];
	static DfaState st543[11];
	static DfaState st544[11];
	static DfaState st545[11];
	static DfaState st546[11];
	static DfaState st547[11];
	static DfaState st548[11];
	static DfaState st549[11];
	static DfaState st550[11];
	static DfaState *dfa[551];
	static DfaState dfa_base[];
	static unsigned char *b_class_no[];
	static DfaState accepts[552];
	static DLGChar alternatives[552];
	static ANTLRTokenType (DLGLexer::*actions[178])();
	static unsigned char shift0[257];
	static unsigned char shift1[257];
	static unsigned char shift2[257];
	static unsigned char shift3[257];
	static unsigned char shift4[257];
	static unsigned char shift5[257];
	int ZZSHIFT(int c) { return b_class_no[automaton][1+c]; }
};
typedef ANTLRTokenType (DLGLexer::*PtrDLGLexerMemberFunc)();
#endif
