/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33j
 */
#include <stdio.h>
#define ANTLR_VERSION	133
#include "tokens.h"

#ifdef _MSC_VER
// Disable some warnings that appear commonly in Rogue Wave STL
#pragma warning (disable:4786)    // long debug names
#pragma warning (disable:4146)    // unary minus operator applied to unsigned type
#pragma warning (disable:4018)    // '>' : signed/unsigned mismatch
#endif
#include "tokens.h"
#include "FastToken.h"
#include "ATokPtr.h"
#include "JLStr.h"
class TokenList;
#include "AParser.h"
#include "CPreParser.h"
#include "DLexerBase.h"
#include "ATokPtr.h"
#ifndef PURIFY
#define PURIFY(r,s)
#endif

void
CPreParser::preprocessing_file(void)
{
	zzRULE;
	Tracer tracer(this, "preprocessing_file");
	int _success = 0;
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
		LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
		LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
		LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
		LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
		LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || 
		LA(1)==171 || LA(1)==172) ) {
			group();
			_success = 1;
		}
	}
	_match(TOK_Eof);
		consume();
	_success = 1;
	return;
}

  bool   
CPreParser::preprocessing_chunk(void)
{
	  bool   	 _retv;
	zzRULE;
	_retv = 1;  
	Tracer tracer(this, "preprocessing_chunk");
	int _success = 0;
	if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
	LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
	LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
	LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
	LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
	LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
	LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
	LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
	LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
	LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
	LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
	LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
	LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
	LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
	LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
	LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
	LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
	LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
	LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
	LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
	LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
	LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
	LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
	LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
	LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
	LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
	LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
	LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
	LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
	LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
	LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
	LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
	LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
	LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || 
	LA(1)==171 || LA(1)==172) ) {
		group_part();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_Eof) ) {
		_match(TOK_Eof);
		
		_retv = 0;   
		consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err1);
	}
	return _retv;
}

void
CPreParser::group(void)
{
	zzRULE;
	Tracer tracer(this, "group");
	int _success = 0;
	{
		int zzcnt=1;
		do {
			int _success = 0;
			if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
			LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
			LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
			LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
			LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
			LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
			LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
			LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
			LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
			LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
			LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
			LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
			LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
			LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
			LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
			LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
			LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
			LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
			LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
			LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
			LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
			LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
			LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
			LA(1)==146 || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || 
			LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
			LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || 
			LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || 
			LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || 
			LA(1)==171 || LA(1)==172) ) {
				group_part();
				_success = 1;
			}
			if ( !_success && zzcnt>1 ) break; /* implied exit branch */
			if (!_success) {
				fail_syntax(err2);
			}
			zzcnt++;
		} while ( 1 );
	}
	_success = 1;
	return;
}

void
CPreParser::group_part(void)
{
	zzRULE;
	Tracer tracer(this, "group_part");
	int _success = 0;
	if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
	LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
	LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
	LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
	LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
	LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
	LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
	LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
	LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
	LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
	LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
	LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
	LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
	LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
	LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
	LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
	LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
	LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
	LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
	LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
	LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
	LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
	LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
	LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
	LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
	LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
	LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
	LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
	LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || LA(1)==146 || 
	LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || 
	LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || 
	LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || LA(1)==172) ) {
		pp_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDIF) ) {
		if_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDIFDEF) ) {
		ifdef_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDIFNDEF) ) {
		ifndef_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDELIF) ) {
		elif_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDELSE) ) {
		else_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDENDIF) ) {
		endif_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PND || LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || 
	LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF) ) {
		control_line();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err3);
	}
	return;
}

void
CPreParser::pp_line(void)
{
	zzRULE;
	;/*init-action*/  
	Tracer tracer(this, "pp_line");
	int _success = 0;
	ClearTokenList(tempTokenList);  
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PRAGMA_END || 
		LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || 
		LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || 
		LA(1)==TOK_CHARACTER || LA(1)==171 || LA(1)==172) ) {
			token_list_for_ppline( IfBlockTrue() );
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
	
	
	if (IfBlockTrue()) 
	{
		ExpandAndOutputTokenList(tempTokenList); 
	}
	consume();
	_success = 1;
	return;
}

void
CPreParser::if_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndif=NULL;
	;/*init-action*/  
	Tracer tracer(this, "if_line");
	int _success = 0;
	ClearTokenList(tempTokenList);  
	_match(TOK_PNDIF);
	
	tokPndif = (ANTLRTokenPtr)LT(1);
	consume();
	token_list( IfBlockTrue() );
	
	if (IfBlockTrue())
	{
		EnterIfBlock(EvaluateExpression(),  tokPndif);
	} else {
		// Already skipping -- do not evaluate expression
		EnterIfBlock(0,  tokPndif);
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::ifdef_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndif=NULL, macroName=NULL;
	;/*init-action*/  
	Tracer tracer(this, "ifdef_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDIFDEF);
	
	tokPndif = (ANTLRTokenPtr)LT(1);
	consume();
	_setmatch(LEGAL_MACRO_NAMES_set);
	
	macroName = (ANTLRTokenPtr)LT(1);

	
	if (IfBlockTrue())
	{
		EnterIfBlock(MacroIsDefined( macroName),  tokPndif);
	} else {
		// Already skipping -- do not evaluate #ifdef
		EnterIfBlock(0,  tokPndif);
	}
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_SLCOMMENT) ) {
			_match(TOK_SLCOMMENT);
						consume();
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::ifndef_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndif=NULL, macroName=NULL;
	;/*init-action*/  
	Tracer tracer(this, "ifndef_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDIFNDEF);
	
	tokPndif = (ANTLRTokenPtr)LT(1);
	consume();
	_setmatch(LEGAL_MACRO_NAMES_set);
	
	macroName = (ANTLRTokenPtr)LT(1);

	
	if (IfBlockTrue())
	{
		EnterIfBlock(!MacroIsDefined( macroName),  tokPndif);
	} else {
		// Already skipping -- do not evaluate #ifndef
		EnterIfBlock(0,  tokPndif);
	}
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_SLCOMMENT) ) {
			_match(TOK_SLCOMMENT);
						consume();
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::elif_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndif=NULL;
	;/*init-action*/  
	Tracer tracer(this, "elif_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDELIF);
	
	tokPndif = (ANTLRTokenPtr)LT(1);
	consume();
	token_list( EnclosingIfBlockTrue() );
	
	if (EnclosingIfBlockTrue())
	{
		EnterElifBlock(EvaluateExpression(),  tokPndif);
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::else_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndelse=NULL;
	Tracer tracer(this, "else_line");
	int _success = 0;
	_match(TOK_PNDELSE);
	
	tokPndelse = (ANTLRTokenPtr)LT(1);

	
	if (EnclosingIfBlockTrue())
	{
		EnterElseBlock( tokPndelse);
	}
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_SLCOMMENT) ) {
			_match(TOK_SLCOMMENT);
						consume();
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::endif_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndendif=NULL;
	Tracer tracer(this, "endif_line");
	int _success = 0;
	_match(TOK_PNDENDIF);
	
	tokPndendif = (ANTLRTokenPtr)LT(1);

	ExitIfBlock( tokPndendif);  
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_SLCOMMENT) ) {
			_match(TOK_SLCOMMENT);
						consume();
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::control_line(void)
{
	zzRULE;
	Tracer tracer(this, "control_line");
	int _success = 0;
	if ((LA(1)==TOK_PNDINCLUDE) ) {
		include_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDDEFINE) ) {
		define_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDUNDEF) ) {
		undef_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDLINE) ) {
		line_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDERROR) ) {
		error_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PNDPRAGMA) ) {
		pragma_line();
		_success = 1;
	}
	if ( !_success &&(LA(1)==TOK_PND) ) {
		_match(TOK_PND);
				consume();
		{
			int _success = 0;
			if ((LA(1)==TOK_SLCOMMENT) ) {
				_match(TOK_SLCOMMENT);
								consume();
				_success = 1;
			}
		}
		_match(TOK_NEWLINE);
				consume();
		_success = 1;
	}
	if (!_success) {
		fail_syntax(err5);
	}
	return;
}

void
CPreParser::include_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndinclude=NULL;
	;/*init-action*/  
	Tracer tracer(this, "include_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDINCLUDE);
	
	tokPndinclude = (ANTLRTokenPtr)LT(1);
	consume();
	token_list( IfBlockTrue() );
	_match(TOK_NEWLINE);
	
	
	if (IfBlockTrue()) 
	{
		IncludeFile( tokPndinclude);
	}
	consume();
	_success = 1;
	return;
}

void
CPreParser::define_line(void)
{
	zzRULE;
	Tracer tracer(this, "define_line");
	int _success = 0;
	_match(TOK_PNDDEFINE);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_FUNCID) ) {
			function_macro_definition();
			_success = 1;
		}
		if ( !_success &&(LA(1)==TOK_ID) ) {
			id_macro_definition();
			_success = 1;
		}
		if (!_success) {
			fail_syntax(err6);
		}
	}
	_success = 1;
	return;
}

void
CPreParser::function_macro_definition(void)
{
	zzRULE;
	ANTLRTokenPtr tokFuncid=NULL;
	;/*init-action*/  
	Tracer tracer(this, "function_macro_definition");
	int _success = 0;
	
	ClearTokenList(tempTokenList);
	ClearTokenList(tempIdentifierList); 
	_match(TOK_FUNCID);
	
	tokFuncid = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || 
		LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || 
		LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID) ) {
			identifier_list( IfBlockTrue() );
			_success = 1;
		}
	}
	_match(TOK_RPAREN);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || 
		LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || 
		LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || 
		LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || 
		LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || 
		LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || 
		LA(1)==172) ) {
			token_list( IfBlockTrue() );
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
	
	if (IfBlockTrue()) EnterFunctionMacro( tokFuncid);   
	consume();
	_success = 1;
	return;
}

void
CPreParser::id_macro_definition(void)
{
	zzRULE;
	ANTLRTokenPtr tokId=NULL;
	;/*init-action*/  
	Tracer tracer(this, "id_macro_definition");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_ID);
	
	tokId = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || 
		LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || 
		LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || 
		LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || 
		LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || 
		LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || 
		LA(1)==172) ) {
			token_list( IfBlockTrue() );
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
	
	if (IfBlockTrue()) EnterSimpleMacro( tokId);   
	consume();
	_success = 1;
	return;
}

void
CPreParser::undef_line(void)
{
	zzRULE;
	ANTLRTokenPtr macroName=NULL;
	Tracer tracer(this, "undef_line");
	int _success = 0;
	_match(TOK_PNDUNDEF);
		consume();
	_setmatch(LEGAL_MACRO_NAMES_set);
	
	macroName = (ANTLRTokenPtr)LT(1);
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_SLCOMMENT) ) {
			_match(TOK_SLCOMMENT);
						consume();
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
	
	if (IfBlockTrue()) UndefineMacro( macroName);   
	consume();
	_success = 1;
	return;
}

void
CPreParser::line_line(void)
{
	zzRULE;
	;/*init-action*/  
	Tracer tracer(this, "line_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDLINE);
		consume();
	token_list( false );
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::error_line(void)
{
	zzRULE;
	;/*init-action*/  
	Tracer tracer(this, "error_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDERROR);
		consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || 
		LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || 
		LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || 
		LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || 
		LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || 
		LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || 
		LA(1)==172) ) {
			token_list( IfBlockTrue() );
			_success = 1;
		}
	}
	_match(TOK_NEWLINE);
	
	if (IfBlockTrue()) HandlePndError();   
	consume();
	_success = 1;
	return;
}

void
CPreParser::pragma_line(void)
{
	zzRULE;
	ANTLRTokenPtr tokPndpragma=NULL;
	;/*init-action*/  
	Tracer tracer(this, "pragma_line");
	int _success = 0;
	ClearTokenList(tempTokenList);   
	_match(TOK_PNDPRAGMA);
	
	tokPndpragma = (ANTLRTokenPtr)LT(1);

	AppendToTokenList(tempTokenList,  tokPndpragma);   
	consume();
	{
		int _success = 0;
		if ((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
		LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
		LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
		LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
		LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
		LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
		LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
		LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
		LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
		LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
		LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
		LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
		LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
		LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
		LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
		LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
		LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
		LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
		LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
		LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
		LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
		LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
		LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
		LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
		LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
		LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
		LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
		LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
		LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || 
		LA(1)==TOK_PNDDEFINE || LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || 
		LA(1)==TOK_PNDELSE || LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || 
		LA(1)==TOK_PNDPRAGMA || LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || 
		LA(1)==162 || LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || 
		LA(1)==167 || LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || 
		LA(1)==172) ) {
			token_list( IfBlockTrue() );
			_success = 1;
		}
	}
	
	if (IfBlockTrue() && GetOption(OptPragmas))
	{
		// Process the pragma
		HandlePragma();
	}
	_match(TOK_NEWLINE);
		consume();
	_success = 1;
	return;
}

void
CPreParser::identifier_list(  bool collecting  )
{
	zzRULE;
	ANTLRTokenPtr id=NULL, id2=NULL;
	Tracer tracer(this, "identifier_list");
	int _success = 0;
	_setmatch(LEGAL_MACRO_NAMES_set);
	
	id = (ANTLRTokenPtr)LT(1);

	if ( collecting) AppendToTokenList(tempIdentifierList,  id);  
	consume();
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_COMMA)))
				break;
			int _success = 0;
			_match(TOK_COMMA);
						consume();
			_setmatch(LEGAL_MACRO_NAMES_set);
			
			id2 = (ANTLRTokenPtr)LT(1);

			if ( collecting) AppendToTokenList(tempIdentifierList,  id2);  
			consume();
			_success = 1;
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return;
}

void
CPreParser::token_list_for_ppline(  bool collecting  )
{
	zzRULE;
	ANTLRTokenPtr macroName=NULL, pndNewline=NULL;
	;  
	Tracer tracer(this, "token_list_for_ppline");
	int _success = 0;
	{
		int zzcnt=1;
		do {
			int _success = 0;
			if ((LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || 
			LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || 
			LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
			LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
			LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
			LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
			LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
			LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
			LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
			LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID)&&(!(((LA(1)==TOK_ASM || LA(1)==TOK_AUTO || 
			LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || 
			LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || 
			LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || 
			LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || 
			LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || 
			LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || 
			LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || 
			LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || 
			LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || 
			LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || 
			LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || 
			LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || 
			LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || 
			LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || 
			LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_ID)))||(collecting && IsFunctionLikeMacro(LT(1)) )) ) {
				if (!(collecting && IsFunctionLikeMacro(LT(1)) )) {fail_predicate("    collecting && IsFunctionLikeMacro(LT(1)) ");}
				_setmatch(LEGAL_MACRO_NAMES_set);
				
				macroName = (ANTLRTokenPtr)LT(1);

				AppendToTokenList(tempTokenList,  macroName);  
				consume();
				{
					while ( 1 ) {
						if ( !((
						LA(1)==TOK_SLCOMMENT || LA(1)==TOK_NEWLINE)))
							break;
						int _success = 0;
						if ((LA(1)==TOK_NEWLINE) ) {
							_match(TOK_NEWLINE);
														consume();
							_success = 1;
						}
						if ( !_success &&(LA(1)==TOK_SLCOMMENT) ) {
							_match(TOK_SLCOMMENT);
														consume();
							_success = 1;
						}
						if ( !_success ) break; /* implied exit branch */
					}
				}
				{
					int _success = 0;
					if ((LA(1)==TOK_LPAREN) ) {
						parenthesized_token_list();
						_success = 1;
					}
				}
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
			LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
			LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
			LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
			LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
			LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
			LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
			LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
			LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
			LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
			LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
			LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
			LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
			LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
			LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
			LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
			LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
			LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
			LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
			LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
			LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
			LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
			LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PRAGMA_END || 
			LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || LA(1)==163 || LA(1)==164 || 
			LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || LA(1)==168 || LA(1)==169 || 
			LA(1)==TOK_CHARACTER || LA(1)==171 || LA(1)==172) ) {
				_setmatch(PND_NEWLINE_set);
				
				pndNewline = (ANTLRTokenPtr)LT(1);

				
				if ( collecting) 
				{
					AppendToTokenList(tempTokenList,  pndNewline);
				}
				consume();
				_success = 1;
			}
			if ( !_success && zzcnt>1 ) break; /* implied exit branch */
			if (!_success) {
				fail_syntax(err8);
			}
			zzcnt++;
		} while ( 1 );
	}
	_success = 1;
	return;
}

void
CPreParser::parenthesized_token_list(void)
{
	zzRULE;
	ANTLRTokenPtr lparen=NULL, rparen=NULL;
	Tracer tracer(this, "parenthesized_token_list");
	int _success = 0;
	_match(TOK_LPAREN);
	
	lparen = (ANTLRTokenPtr)LT(1);

	AppendToTokenList(tempTokenList,  lparen);  
	consume();
	token_list_no_rparen();
	_match(TOK_RPAREN);
	
	rparen = (ANTLRTokenPtr)LT(1);

	AppendToTokenList(tempTokenList,  rparen);  
	consume();
	_success = 1;
	return;
}

void
CPreParser::token_list_no_rparen(void)
{
	zzRULE;
	ANTLRTokenPtr whatever=NULL;
	Tracer tracer(this, "token_list_no_rparen");
	int _success = 0;
	{
		while ( 1 ) {
			if ( !((LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || 
			LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || 
			LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || 
			LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || 
			LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || 
			LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || 
			LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || 
			LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || 
			LA(1)==TOK_RCURLY || LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || 
			LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || 
			LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || 
			LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || 
			LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || 
			LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || 
			LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || 
			LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || 
			LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || 
			LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || 
			LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || 
			LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || 
			LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || 
			LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || 
			LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || 
			LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || 
			LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || 
			LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || 
			LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || 
			LA(1)==135 || LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || 
			LA(1)==140 || LA(1)==TOK_SLCOMMENT || LA(1)==TOK_PNDPND || LA(1)==TOK_NEWLINE || LA(1)==TOK_PP_NUMBER || 
			LA(1)==146 || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || 
			LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || 
			LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || LA(1)==172)))
				break;
			int _success = 0;
			if ((LA(1)==TOK_LPAREN) ) {
				parenthesized_token_list();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_SLCOMMENT) ) {
				_match(TOK_SLCOMMENT);
								consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
			LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
			LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
			LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
			LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || LA(1)==TOK_MINUSEQUAL || 
			LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || LA(1)==TOK_NOTEQUAL || 
			LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || LA(1)==TOK_POINTERTO || 
			LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || 
			LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || 
			LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || LA(1)==TOK_ASM || LA(1)==TOK_AUTO || 
			LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || LA(1)==TOK_BREAK || LA(1)==TOK_CASE || 
			LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || 
			LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || LA(1)==TOK_DELETE || LA(1)==TOK_DO || 
			LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || 
			LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || 
			LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || 
			LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || 
			LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || 
			LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || 
			LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || LA(1)==TOK_THROW || LA(1)==TOK_TRY || 
			LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || 
			LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || 
			LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || 
			LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || 
			LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || 
			LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || 
			LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || LA(1)==136 || LA(1)==137 || 
			LA(1)==138 || LA(1)==139 || LA(1)==140 || LA(1)==TOK_PNDPND || LA(1)==TOK_PP_NUMBER || 
			LA(1)==146 || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || 
			LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || 
			LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || LA(1)==172) ) {
				_setmatch(LRPAREN_DIRECTIVE_SLCOMMENT_NEWLINE_set);
				
				whatever = (ANTLRTokenPtr)LT(1);

				AppendToTokenList(tempTokenList,  whatever);  
				consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_NEWLINE) ) {
				_match(TOK_NEWLINE);
								consume();
				_success = 1;
			}
			if ( !_success ) break; /* implied exit branch */
		}
	}
	_success = 1;
	return;
}

void
CPreParser::token_list(  bool collecting  )
{
	zzRULE;
	ANTLRTokenPtr whatever=NULL;
	Tracer tracer(this, "token_list");
	int _success = 0;
	{
		int zzcnt=1;
		do {
			int _success = 0;
			if ((LA(1)==TOK_SLCOMMENT) ) {
				_match(TOK_SLCOMMENT);
								consume();
				_success = 1;
			}
			if ( !_success &&(LA(1)==TOK_AMPERSAND || LA(1)==TOK_AND || LA(1)==TOK_ASSIGNEQUAL || LA(1)==TOK_BITWISEANDEQUAL || 
			LA(1)==TOK_BITWISEOR || LA(1)==TOK_BITWISEOREQUAL || LA(1)==TOK_BITWISEXOR || LA(1)==TOK_BITWISEXOREQUAL || LA(1)==TOK_COMMA || 
			LA(1)==TOK_COLON || LA(1)==TOK_DIVIDE || LA(1)==TOK_DIVIDEEQUAL || LA(1)==TOK_DOT || LA(1)==TOK_DOTMBR || 
			LA(1)==TOK_ELLIPSIS || LA(1)==TOK_EQUAL || LA(1)==TOK_GREATERTHAN || LA(1)==TOK_GREATERTHANOREQUALTO || LA(1)==TOK_LCURLY || 
			LA(1)==TOK_LESSTHAN || LA(1)==TOK_LESSTHANOREQUALTO || LA(1)==TOK_LPAREN || LA(1)==TOK_LSQUARE || LA(1)==TOK_MINUS || 
			LA(1)==TOK_MINUSEQUAL || LA(1)==TOK_MINUSMINUS || LA(1)==TOK_MOD || LA(1)==TOK_MODEQUAL || LA(1)==TOK_NOT || 
			LA(1)==TOK_NOTEQUAL || LA(1)==TOK_OR || LA(1)==TOK_PLUS || LA(1)==TOK_PLUSEQUAL || LA(1)==TOK_PLUSPLUS || 
			LA(1)==TOK_POINTERTO || LA(1)==TOK_POINTERTOMBR || LA(1)==TOK_QUESTIONMARK || LA(1)==TOK_RCURLY || LA(1)==TOK_RPAREN || 
			LA(1)==TOK_RSQUARE || LA(1)==TOK_SCOPE || LA(1)==TOK_SEMICOLON || LA(1)==TOK_SHIFTLEFT || LA(1)==TOK_SHIFTLEFTEQUAL || 
			LA(1)==TOK_SHIFTRIGHT || LA(1)==TOK_SHIFTRIGHTEQUAL || LA(1)==TOK_STAR || LA(1)==TOK_TILDE || LA(1)==TOK_TIMESEQUAL || 
			LA(1)==TOK_ASM || LA(1)==TOK_AUTO || LA(1)==TOK_BOOL || LA(1)==TOK_BOOLFALSE || LA(1)==TOK_BOOLTRUE || 
			LA(1)==TOK_BREAK || LA(1)==TOK_CASE || LA(1)==TOK_CATCH || LA(1)==TOK_CHAR || LA(1)==TOK_CLASS || 
			LA(1)==TOK_CONST || LA(1)==TOK_CONST_CAST || LA(1)==TOK_CONTINUE || LA(1)==TOK_DEFAULT || LA(1)==TOK_DEFINED || 
			LA(1)==TOK_DELETE || LA(1)==TOK_DO || LA(1)==TOK_DOUBLE || LA(1)==TOK_DYNAMIC_CAST || LA(1)==TOK_ELSE || 
			LA(1)==TOK_ENUM || LA(1)==TOK_EXPLICIT || LA(1)==TOK_EXTERN || LA(1)==TOK_FLOAT || LA(1)==TOK_FOR || 
			LA(1)==TOK_FRIEND || LA(1)==TOK_GOTO || LA(1)==TOK_IF || LA(1)==TOK_INLINE || LA(1)==TOK_INT || 
			LA(1)==TOK_LONG || LA(1)==TOK_MUTABLE || LA(1)==TOK_NAMESPACE || LA(1)==TOK_NEW || LA(1)==TOK_OPERATOR || 
			LA(1)==TOK_PRIVATE || LA(1)==TOK_PROTECTED || LA(1)==TOK_PUBLIC || LA(1)==TOK_REGISTER || LA(1)==TOK_REINTERPRET_CAST || 
			LA(1)==TOK_RETURN || LA(1)==TOK_SHORT || LA(1)==TOK_SIGNED || LA(1)==TOK_SIZEOF || LA(1)==TOK_STATIC || 
			LA(1)==TOK_STATIC_CAST || LA(1)==TOK_STRUCT || LA(1)==TOK_SWITCH || LA(1)==TOK_TEMPLATE || LA(1)==TOK_THIS || 
			LA(1)==TOK_THROW || LA(1)==TOK_TRY || LA(1)==TOK_TYPEDEF || LA(1)==TOK_TYPEID || LA(1)==TOK_TYPENAME || 
			LA(1)==TOK_UNION || LA(1)==TOK_UNSIGNED || LA(1)==TOK_USING || LA(1)==TOK_VIRTUAL || LA(1)==TOK_VOID || 
			LA(1)==TOK_VOLATILE || LA(1)==TOK_WCHAR_T || LA(1)==TOK_WHILE || LA(1)==TOK_MSEXT_INT8 || LA(1)==TOK_MSEXT_INT16 || 
			LA(1)==TOK_MSEXT_INT32 || LA(1)==TOK_MSEXT_INT64 || LA(1)==TOK_MSEXT_BASED || LA(1)==TOK_MSEXT_DECLSPEC || LA(1)==TOK_MSEXT_CDECL || 
			LA(1)==TOK_MSEXT_FASTCALL || LA(1)==TOK_MSEXT_STDCALL || LA(1)==TOK_MSEXT_TRY || LA(1)==TOK_MSEXT_EXCEPT || LA(1)==TOK_MSEXT_FINALLY || 
			LA(1)==TOK_MSEXT_LEAVE || LA(1)==TOK_MSEXT_INLINE || LA(1)==TOK_MSEXT_ASM || LA(1)==TOK_ID || LA(1)==TOK_OCTALINT || 
			LA(1)==TOK_DECIMALINT || LA(1)==TOK_HEXADECIMALINT || LA(1)==TOK_FLOATONE || LA(1)==TOK_FLOATTWO || LA(1)==135 || 
			LA(1)==136 || LA(1)==137 || LA(1)==138 || LA(1)==139 || LA(1)==140 || 
			LA(1)==TOK_PNDPND || LA(1)==TOK_PND || LA(1)==TOK_PP_NUMBER || LA(1)==146 || LA(1)==TOK_PNDDEFINE || 
			LA(1)==TOK_PNDIF || LA(1)==TOK_PNDIFDEF || LA(1)==TOK_PNDIFNDEF || LA(1)==TOK_PNDELIF || LA(1)==TOK_PNDELSE || 
			LA(1)==TOK_PNDENDIF || LA(1)==TOK_PNDERROR || LA(1)==TOK_PNDINCLUDE || LA(1)==TOK_PNDLINE || LA(1)==TOK_PNDPRAGMA || 
			LA(1)==TOK_PNDUNDEF || LA(1)==TOK_PRAGMA_END || LA(1)==160 || LA(1)==TOK_FUNCID || LA(1)==162 || 
			LA(1)==163 || LA(1)==164 || LA(1)==165 || LA(1)==TOK_STRING || LA(1)==167 || 
			LA(1)==168 || LA(1)==169 || LA(1)==TOK_CHARACTER || LA(1)==171 || LA(1)==172) ) {
				_setmatch(SLCOMMENT_NEWLINE_set);
				
				whatever = (ANTLRTokenPtr)LT(1);

				if ( collecting) AppendToTokenList(tempTokenList,  whatever);  
				consume();
				_success = 1;
			}
			if ( !_success && zzcnt>1 ) break; /* implied exit branch */
			if (!_success) {
				fail_syntax(err11);
			}
			zzcnt++;
		} while ( 1 );
	}
	_success = 1;
	return;
}
