// cpre_options.cpp: option management for the preprocessor

#include "CPreParserImp.h"
#include <set>

///////////////////////////////////////////////////////////////////////
void 
CPreParserImp::SetOption(
   Option opt, 
   bool value
)
{
   if (value)
   {
      options->insert((int)opt);
   } else {
      options->erase((int)opt);
   }
}


///////////////////////////////////////////////////////////////////////
bool 
CPreParserImp::GetOption(
   Option opt
) const
{
   return options->find((int)opt) != options->end();
}

