#ifndef DLGLexer_h
#define DLGLexer_h
/*
 * D L G L e x e r  C l a s s  D e f i n i t i o n
 *
 * Generated from: parser.dlg
 *
 * 1989-1994 by  Will Cohen, Terence Parr, and Hank Dietz
 * Purdue University Electrical Engineering
 * DLG Version 1.33
 */


#include "DLexerBase.h"

class DLGLexer : public DLGLexerBase {
public:
	static const int MAX_MODE;
	static const int DfaStates;
	static const int START;
	typedef unsigned char DfaState;

	DLGLexer(DLGInputStream *in,
		unsigned bufsize=2000)
		: DLGLexerBase(in, bufsize, 1)
		  , firstLineToken(1)
	{
	;
	}
	void	mode(int);
	ANTLRTokenType nextTokenType(void);
	void	advance(void);
	int firstLineToken;
protected:
	ANTLRTokenType act1();
	ANTLRTokenType act2();
	ANTLRTokenType act3();
	ANTLRTokenType act4();
	ANTLRTokenType act5();
	ANTLRTokenType act6();
	static DfaState st0[7];
	static DfaState st1[7];
	static DfaState st2[7];
	static DfaState st3[7];
	static DfaState st4[7];
	static DfaState st5[7];
	static DfaState st6[7];
	static DfaState *dfa[7];
	static DfaState dfa_base[];
	static unsigned char *b_class_no[];
	static DfaState accepts[8];
	static DLGChar alternatives[8];
	static ANTLRTokenType (DLGLexer::*actions[7])();
	static unsigned char shift0[257];
	int ZZSHIFT(int c) { return b_class_no[automaton][1+c]; }
};
typedef ANTLRTokenType (DLGLexer::*PtrDLGLexerMemberFunc)();
#endif
