// CPPDeclContainers.h: Implementation of containers of declarations

#ifndef INCL_CPPDECLCONTAINERS_H
#define INCL_CPPDECLCONTAINERS_H

#include "CPPDeclIncomplete.h"
#include "JLStr.h"
#include "JL_DList.h"
#include <map>

typedef multimap<JLStr, CPPDeclRefI, less<JLStr>, allocator<CPPDeclRefI> > RawCPPDeclTable;
class CPPDeclTable : public VRefCount, public RawCPPDeclTable
{
};

typedef JL_DList<CPPDeclRefI, allocator<CPPDeclRefI> > RawCPPDeclList;
class CPPDeclList : public VRefCount, public RawCPPDeclList
{
};

#endif
