// CPPScopeState.h: Definition of CPPScopeState type

#ifndef INCL_CPPSCOPESTATE_H
#define INCL_CPPSCOPESTATE_H

struct CPPScopeState { 
   CPPScopeState() : position(0) {}
   CPPScopeState(int p) : position(p) {} 
   bool operator==(const CPPScopeState& rhs) const { return position == rhs.position; }
   bool operator!=(const CPPScopeState& rhs) const { return !operator==(rhs); }
   int position; 
};

#endif
