// TokenListList.h:  Definition of a list of token lists.

#ifndef INCL_TOKENLISTLIST_H
#define INCL_TOKENLISTLIST_H

#pragma warning (disable:4786)    // long debug names

#include <JL_DList.h>
#include "TokenListIncomplete.h"

///////////////////////////////////////////////////////////////////////
//                     List of token lists
///////////////////////////////////////////////////////////////////////

typedef JL_DList<TokenListRefI, allocator<TokenListRefI> > RawTokenListList;

// Does not need any implementation other than that provided by base classes.
class TokenListList : public VRefCount, public RawTokenListList
{
};

#endif

