/*
 * CPreExpr: P a r s e r  H e a d e r 
 *
 * Generated from: cpre_expr.g
 *
 * Terence Parr, Russell Quong, Will Cohen, and Hank Dietz: 1989-1995
 * Parr Research Corporation
 * with Purdue University Electrical Engineering
 * with AHPCRC, University of Minnesota
 * ANTLR Version 1.33j
 */

#ifndef CPreExpr_h
#define CPreExpr_h

#include "FastToken.h"
#include "ATokPtr.h"
//typedef FastToken ANTLRToken;

#ifdef _MSC_VER
// MSVC++ doesn't grok bool, so include an STL header since they define
// bool and we'd like the same bool defined everywhere.  This works
// for both Rogue Wave and MSVC++ STL.
#include <new>
#endif

#include "cpre_expr_support.h"
#include "AParser.h"

class CPreExpr : public ANTLRParser {
public:
	enum ANTLRConstants { ConstLLK = 1 };
protected:
	static const ANTLRChar * const _token_tbl[];
public:
	static const ANTLRChar* const * GetTokenTable() { return _token_tbl; }
private:

public:
virtual void init();
protected:
CPreValue ConvertOctal(ANTLRTokenPtr token) const;
CPreValue ConvertDecimal(ANTLRTokenPtr token) const;
CPreValue ConvertHexadecimal(ANTLRTokenPtr token) const;
CPreValue ConvertCharacter(ANTLRTokenPtr token) const;
CPreValue ConvertFloat(ANTLRTokenPtr token) const;

  
	static SetWordType EQUALITY_OPERATOR_set[24];
	static SetWordType RELATIONAL_OPERATOR_set[24];
	static SetWordType SHIFT_OPERATOR_set[24];
	static SetWordType ADDITIVE_OPERATOR_set[24];
	static SetWordType MULTIPLICATIVE_OPERATOR_set[24];
	static SetWordType UNARY_OPERATOR_set[24];
	static SetWordType err7[24];
	static SetWordType err8[24];
	static SetWordType err9[24];
	static SetWordType setwd1[177];
private:
	void zzdflthandlers( int _signal, int *_retsignal );

public:
	CPreExpr(ANTLRTokenBuffer *input);
	  CPreValue    constant_expression(void);
	  CPreValue    logical_or_expression(void);
	  CPreValue    logical_and_expression(void);
	  CPreValue    inclusive_or_expression(void);
	  CPreValue    exclusive_or_expression(void);
	  CPreValue    and_expression(void);
	  CPreValue    equality_expression(void);
	  CPreValue    relational_expression(void);
	  CPreValue    shift_expression(void);
	  CPreValue    additive_expression(void);
	  CPreValue    multiplicative_expression(void);
	  CPreValue    unary_expression(void);
	  CPreValue    primary_expression(void);
	  CPreValue    constant(void);
};

#endif /* CPreExpr_h */
