// cpre_support.cpp: misc. support methods for the preprocessor

#include "CPreParserImp.h"
#include "tokenList.h"

///////////////////////////////////////////////////////////////////////
//                          Misc                                     //
///////////////////////////////////////////////////////////////////////
bool CPreParserImp::TokenCanBeDefined(const ANTLRTokenPtr& token)
{
   return (bool)set_el(token->getType(), LEGAL_MACRO_NAMES_set);
}

void CPreParserImp::ClearTokenList(
   TokenList* tokenList
)
{
   tokenList->erase(tokenList->begin(), tokenList->end());
}

void CPreParserImp::AppendToTokenList(
   TokenList* tokenList, 
   const ANTLRTokenPtr& tokPtr
)
{
   tokenList->push_back(tokPtr);
}
