#ifndef tokens_h
#define tokens_h
/* tokens.h -- List of labelled tokens and stuff
 *
 * Generated from: cpre.g
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * ANTLR Version 1.33j
 */
enum ANTLRTokenType {
	TOK_Eof=1,
	TOK_AMPERSAND=2,
	TOK_AND=3,
	TOK_ASSIGNEQUAL=4,
	TOK_BITWISEANDEQUAL=5,
	TOK_BITWISEOR=6,
	TOK_BITWISEOREQUAL=7,
	TOK_BITWISEXOR=8,
	TOK_BITWISEXOREQUAL=9,
	TOK_COMMA=10,
	TOK_COLON=11,
	TOK_DIVIDE=12,
	TOK_DIVIDEEQUAL=13,
	TOK_DOT=14,
	TOK_DOTMBR=15,
	TOK_ELLIPSIS=16,
	TOK_EQUAL=17,
	TOK_GREATERTHAN=18,
	TOK_GREATERTHANOREQUALTO=19,
	TOK_LCURLY=20,
	TOK_LESSTHAN=21,
	TOK_LESSTHANOREQUALTO=22,
	TOK_LPAREN=23,
	TOK_LSQUARE=24,
	TOK_MINUS=25,
	TOK_MINUSEQUAL=26,
	TOK_MINUSMINUS=27,
	TOK_MOD=28,
	TOK_MODEQUAL=29,
	TOK_NOT=30,
	TOK_NOTEQUAL=31,
	TOK_OR=32,
	TOK_PLUS=33,
	TOK_PLUSEQUAL=34,
	TOK_PLUSPLUS=35,
	TOK_POINTERTO=36,
	TOK_POINTERTOMBR=37,
	TOK_QUESTIONMARK=38,
	TOK_RCURLY=39,
	TOK_RPAREN=40,
	TOK_RSQUARE=41,
	TOK_SCOPE=42,
	TOK_SEMICOLON=43,
	TOK_SHIFTLEFT=44,
	TOK_SHIFTLEFTEQUAL=45,
	TOK_SHIFTRIGHT=46,
	TOK_SHIFTRIGHTEQUAL=47,
	TOK_STAR=48,
	TOK_TILDE=49,
	TOK_TIMESEQUAL=50,
	TOK_ASM=51,
	TOK_AUTO=52,
	TOK_BOOL=53,
	TOK_BOOLFALSE=54,
	TOK_BOOLTRUE=55,
	TOK_BREAK=56,
	TOK_CASE=57,
	TOK_CATCH=58,
	TOK_CHAR=59,
	TOK_CLASS=60,
	TOK_CONST=61,
	TOK_CONST_CAST=62,
	TOK_CONTINUE=63,
	TOK_DEFAULT=64,
	TOK_DEFINED=65,
	TOK_DELETE=66,
	TOK_DO=67,
	TOK_DOUBLE=68,
	TOK_DYNAMIC_CAST=69,
	TOK_ELSE=70,
	TOK_ENUM=71,
	TOK_EXPLICIT=72,
	TOK_EXTERN=73,
	TOK_FLOAT=74,
	TOK_FOR=75,
	TOK_FRIEND=76,
	TOK_GOTO=77,
	TOK_IF=78,
	TOK_INLINE=79,
	TOK_INT=80,
	TOK_LONG=81,
	TOK_MUTABLE=82,
	TOK_NAMESPACE=83,
	TOK_NEW=84,
	TOK_OPERATOR=85,
	TOK_PRIVATE=86,
	TOK_PROTECTED=87,
	TOK_PUBLIC=88,
	TOK_REGISTER=89,
	TOK_REINTERPRET_CAST=90,
	TOK_RETURN=91,
	TOK_SHORT=92,
	TOK_SIGNED=93,
	TOK_SIZEOF=94,
	TOK_STATIC=95,
	TOK_STATIC_CAST=96,
	TOK_STRUCT=97,
	TOK_SWITCH=98,
	TOK_TEMPLATE=99,
	TOK_THIS=100,
	TOK_THROW=101,
	TOK_TRY=102,
	TOK_TYPEDEF=103,
	TOK_TYPEID=104,
	TOK_TYPENAME=105,
	TOK_UNION=106,
	TOK_UNSIGNED=107,
	TOK_USING=108,
	TOK_VIRTUAL=109,
	TOK_VOID=110,
	TOK_VOLATILE=111,
	TOK_WCHAR_T=112,
	TOK_WHILE=113,
	TOK_MSEXT_INT8=114,
	TOK_MSEXT_INT16=115,
	TOK_MSEXT_INT32=116,
	TOK_MSEXT_INT64=117,
	TOK_MSEXT_BASED=118,
	TOK_MSEXT_DECLSPEC=119,
	TOK_MSEXT_CDECL=120,
	TOK_MSEXT_FASTCALL=121,
	TOK_MSEXT_STDCALL=122,
	TOK_MSEXT_TRY=123,
	TOK_MSEXT_EXCEPT=124,
	TOK_MSEXT_FINALLY=125,
	TOK_MSEXT_LEAVE=126,
	TOK_MSEXT_INLINE=127,
	TOK_MSEXT_ASM=128,
	TOK_ID=129,
	TOK_OCTALINT=130,
	TOK_DECIMALINT=131,
	TOK_HEXADECIMALINT=132,
	TOK_FLOATONE=133,
	TOK_FLOATTWO=134,
	TOK_SLCOMMENT=141,
	TOK_PNDPND=142,
	TOK_PND=143,
	TOK_NEWLINE=144,
	TOK_PP_NUMBER=145,
	TOK_PNDDEFINE=147,
	TOK_PNDIF=148,
	TOK_PNDIFDEF=149,
	TOK_PNDIFNDEF=150,
	TOK_PNDELIF=151,
	TOK_PNDELSE=152,
	TOK_PNDENDIF=153,
	TOK_PNDERROR=154,
	TOK_PNDINCLUDE=155,
	TOK_PNDLINE=156,
	TOK_PNDPRAGMA=157,
	TOK_PNDUNDEF=158,
	TOK_PRAGMA_END=159,
	TOK_FUNCID=161,
	TOK_STRING=166,
	TOK_CHARACTER=170};

#endif
