#include <stdio.h>
#include "errout.h"

void OutputErrHdr(
	int outputType,
	char *filename,
	int lineno
)
{
	if (BorMsgs)
	{
		/* Borland Format */
		switch (outputType)
		{
			case OUTPUT_WARNING:
				fprintf(stdout, "Warning ");
				break;
			case OUTPUT_ERROR:
				fprintf(stdout, "Error ");
				break;
			case OUTPUT_FATAL:
			default:
				fprintf(stdout, "Fatal ");
				break;
		}
		fprintf(stdout, "%s %d : ", filename, lineno);
	} else {
		/* MSVC++ Format */
		fprintf(stdout, "%s(%d) : ", filename, lineno);
		switch (outputType)
		{
			case OUTPUT_WARNING:
				fprintf(stdout, "Warning ");
				break;
			case OUTPUT_ERROR:
				fprintf(stdout, "Error ");
				break;
			case OUTPUT_FATAL:
			default:
				fprintf(stdout, "Fatal ");
				break;
		}
	}
}

