
/* parser.dlg -- DLG Description of scanner
 *
 * Generated from: test.g
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33j
 */

#include "tokens.h"
#include "AToken.h"
#include "MyZZPred.h"  
/*
 * D L G tables
 *
 * Generated from: parser.dlg
 *
 * 1989-1994 by  Will Cohen, Terence Parr, and Hank Dietz
 * Purdue University Electrical Engineering
 * DLG Version 1.33
 */

#include <stdio.h>

#include "AParser.h"
#include "DLexerBase.h"
#include "DLGLexer.h"

ANTLRTokenType DLGLexer::act1()
{ 
		return Eof;
	}


ANTLRTokenType DLGLexer::act2()
{ 
		skip();   
		return (ANTLRTokenType)2;
	}


ANTLRTokenType DLGLexer::act3()
{ 
		return A;
	}


ANTLRTokenType DLGLexer::act4()
{ 
		return B;
	}


ANTLRTokenType DLGLexer::act5()
{ 
		return C;
	}


ANTLRTokenType DLGLexer::act6()
{ 
		return D;
	}

 unsigned char DLGLexer::shift0[257] = {
  0, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  1, 1, 6, 6, 1, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 2, 3, 4, 5, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 2, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6
};


const int DLGLexer::MAX_MODE=1;
const int DLGLexer::DfaStates=7;
const int DLGLexer::START=0;

DLGLexer::DfaState DLGLexer::st0[7] = {
  1, 2, 3, 4, 5, 6, 7
};

DLGLexer::DfaState DLGLexer::st1[7] = {
  7, 7, 7, 7, 7, 7, 7
};

DLGLexer::DfaState DLGLexer::st2[7] = {
  7, 7, 7, 7, 7, 7, 7
};

DLGLexer::DfaState DLGLexer::st3[7] = {
  7, 7, 7, 7, 7, 7, 7
};

DLGLexer::DfaState DLGLexer::st4[7] = {
  7, 7, 7, 7, 7, 7, 7
};

DLGLexer::DfaState DLGLexer::st5[7] = {
  7, 7, 7, 7, 7, 7, 7
};

DLGLexer::DfaState DLGLexer::st6[7] = {
  7, 7, 7, 7, 7, 7, 7
};


DLGLexer::DfaState *DLGLexer::dfa[7] = {
	st0,
	st1,
	st2,
	st3,
	st4,
	st5,
	st6
};


DLGLexer::DfaState DLGLexer::accepts[8] = {
  0, 1, 2, 3, 4, 5, 6, 0
};

PtrDLGLexerMemberFunc DLGLexer::actions[7] = {
	&DLGLexer::erraction,
	&DLGLexer::act1,
	&DLGLexer::act2,
	&DLGLexer::act3,
	&DLGLexer::act4,
	&DLGLexer::act5,
	&DLGLexer::act6
};

DLGLexer::DfaState DLGLexer::dfa_base[] = {
	0
};

 unsigned char *DLGLexer::b_class_no[] = {
	shift0
};

DLGChar DLGLexer::alternatives[DLGLexer::DfaStates+1] = {
	1,
	0,
	0,
	0,
	0,
	0,
	0,
/* must have 0 for zzalternatives[DfaStates] */
	0
};

#include "DLexer.cpp"
